#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include "kfz.h"

extern DmOpenRef kfz_db;
wlist *select_list = NULL;

static Boolean kennzeichen_select (EventType *event)
{
   FormPtr form;
   ListPtr list;
   FieldPtr search;
   int handled = 0;
   int i, len, rc;
   char tmp[32], tmp1[32], tmp2[32], tmp3[32];
   CharPtr s1, s2;

   form = FrmGetActiveForm();

   switch (event->eType) {
      case frmOpenEvent:
	 list = FrmGetObjectPtr(form, FrmGetObjectIndex(form, listID_kennzeichen));
	 LstEraseList(list);
	 select_list = get_kennzeichen(select_list);
	 LstSetListChoices (list, select_list->wtab, select_list->nwords);
	 LstSetTopItem(list, 0);
	 search = FrmGetObjectPtr(form, FrmGetObjectIndex(form, fieldID_search));
	 FrmDrawForm(form);
	 handled = 1;
	 break;

      case frmCloseEvent:
         delwlist(select_list);
         select_list = NULL;
         break;

      case frmUpdateEvent:
	 list = FrmGetObjectPtr(form, FrmGetObjectIndex(form, listID_kennzeichen));
	 FrmDrawForm(form);
	 LstDrawList(list);
	 handled = 1;
	 break;

      case keyDownEvent:
         if (event->data.keyDown.chr > 31) {
	    if (!select_list || select_list->nwords <= 0) break;
	    search = FrmGetObjectPtr(form, FrmGetObjectIndex(form, fieldID_search));
	    list = FrmGetObjectPtr(form, FrmGetObjectIndex(form, listID_kennzeichen));
            s1 = FldGetTextPtr(search);
            *tmp = 0;
            if (s1 && *s1) StrCopy (tmp, s1);
	    s1 = tmp + StrLen(tmp);
            *(s1++) = event->data.keyDown.chr; // copy the actual char to <tmp>
            *s1 = 0;
            s1 = tmp;
	    len = StrLen(s1);
	    if (len <= 0) break;
	    i = 0;
	    while (i < select_list->nwords) {
	       s2 = select_list->wtab[i];
	       rc = StrNCaselessCompare(s1, s2, len);
	       if (rc <= 0) {
		  if (rc < 0) {
		     i--;
		     handled = 1;
		     SndPlaySystemSound(sndWarning);
		  }
		  break;
	       }
	       i++;
	    }
	    if (i >= 0 && i < select_list->nwords) {
	       rc = i - 3;
	       if (rc < 0) rc = 0;
	       // LstSetSelection(list, -1);
	       // LstSetTopItem(list, rc);
	       // LstDrawList(list);
	       LstSetSelection(list, i);
            }
         } else if (event->data.keyDown.chr > 0) {
	    list = FrmGetObjectPtr(form, FrmGetObjectIndex(form, listID_kennzeichen));
	    switch (event->data.keyDown.chr) {
	       case 11:		/* KEY-Up */
	          LstScrollList(list, up, 11);
	          handled = 1;
	          break;
	       case 12:		/* KEY-Down */
	          LstScrollList(list, down, 11);
	          handled = 1;
	          break;
	    }
         } else {
	    StrPrintF(tmp1, "keyDownEvent");
            StrPrintF(tmp2, "character: %d", event->data.keyDown.chr);
            StrPrintF(tmp3, "button: %d", event->data.keyDown.keyCode);
            FrmCustomAlert(alertID_info,  tmp1, tmp2, tmp3);
	 }
         break;

      case lstSelectEvent:
	 kennzeichen_show (event->data.lstSelect.selection);
	 handled = 1;
         break;

      case ctlSelectEvent:
	 break;
      case nilEvent:
	 break;
   }
   return handled;
}

static void EventLoop (void)
{
   short err;
   int formID;
   FormPtr form;
   EventType event;

   do {
      EvtGetEvent(&event, -1);
      if (SysHandleEvent (&event)) continue;
      if (MenuHandleEvent ((void *) 0, &event, &err)) continue;

      switch (event.eType) {
	 case frmLoadEvent:
	    formID = event.data.frmLoad.formID;
	    form = FrmInitForm(formID);
	    FrmSetActiveForm(form);
	    switch (formID) {
	       case formID_kfz:
		  FrmSetEventHandler(form, (FormEventHandlerPtr) kennzeichen_select);
		  break;
	    }
      }
      FrmDispatchEvent(&event);
   } while (event.eType != appStopEvent);
}

static int StartApplication (void)
{
   if (OpenDatabase()) {
      CloseDatabase();
      return -1;
   }
   FrmGotoForm(formID_kfz);
   return 0;
}

static void StopApplication (void)
{
   CloseDatabase();
}

DWord PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
   Word error;

   switch (cmd) {
      case sysAppLaunchCmdNormalLaunch:
	 error = StartApplication();
	 if (error) return error;
	 EventLoop();
	 StopApplication();
	 break;
   }
   return 0;
}
