#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include "kfz.h"

DmOpenRef	kfz_db;

#define KFZ_DBNAME	"Kennzeichen"
#define KFZ_DBTYPE	'Kenn'

// #define DEBUG_LIST

static struct dbinit {
   char			*dbname;
   unsigned long	 dbtype;
   DmOpenRef		*db;
} dbinit[] = {
   { KFZ_DBNAME, KFZ_DBTYPE, &kfz_db },
   { NULL, 0, NULL }
};

Boolean OpenDatabase (void)
{
   int error;
   struct dbinit *dbip = dbinit;
   DmOpenRef tmpDB;

   while (dbip && dbip->dbname && *dbip->dbname) {
      error = DmCreateDatabase(0, dbip->dbname, APPID, dbip->dbtype, false);
      if (error && error != dmErrAlreadyExists) return true;
      tmpDB = DmOpenDatabaseByTypeCreator(dbip->dbtype, APPID, dmModeReadWrite);
      *dbip->db = tmpDB;
      if (!tmpDB) return true;
      dbip++;
   }

   return 0;
}

void CloseDatabase (void)
{
   struct dbinit *dbip = dbinit;

   while (dbip && dbip->dbname && *dbip->dbname) {
      if (*dbip->db) DmCloseDatabase (*dbip->db);
      dbip++;
   }
}

#if 0
Int stat_compare (void *p1, void *p2, Int ignore1,
		  SortRecordInfoPtr ignore2, SortRecordInfoPtr ignore3,
		  VoidHand ignore4)
{
   int result;
   ULong n, n1, n2;
   VoidHand h1, h2;

   h1 = MemPtrRecoverHandle(p1);
   h2 = MemPtrRecoverHandle(p2);
   n1 = MemHandleSize(h1);
   n2 = MemHandleSize(h2);
   n = min(n1, n2);
   result = StrNCaselessCompare((char *) p1, (char *) p2, n);
   if (!result) result = StrNCompare((char *) p1, (char *) p2, n);
   if (!result) result = n1 > n2;
   return result;
}
#endif

void kennzeichen_show (UInt idx)
{
   VoidHand rec;
   void *kennz;
   char *ort, *land;

   if ((rec = DmQueryRecord(kfz_db, idx)) != 0) {
      kennz = MemHandleLock(rec);
      ort = kennz + StrLen(kennz) + 1;
      land = ort + StrLen(ort) + 1;
      FrmCustomAlert(alertID_details, kennz, ort, land);
   }
}

wlist *get_kennzeichen(wlist *w)
{
   VoidHand rec;
   void *p;
   int idx = 0;
   char *s, tmp[128];

   if (w) delwlist(w);
   w = genwlist();
   if (!w) return NULL;

   while (w && (rec = DmQueryRecord(kfz_db, idx)) != 0) {
      p = MemHandleLock(rec);
      StrCopy (tmp, p);
      s = p + StrLen(p) + 1;
      StrCat (tmp, "   ");
      StrCat (tmp, s);
      w = addwlist(w, tmp);
      MemHandleUnlock(rec);
      idx++;
   }

   return w;
}
