#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include "kfz.h"

#define TMPBUFSIZ	512

char *tmpstr(int len)
{
   static char buf[TMPBUFSIZ], *bufp = buf;
   static int i = 0;
   int allocsize = 16;	// minimum allocation unit
   char *ret;

   if (len > (TMPBUFSIZ >> 1)) return NULL;

   while (allocsize < len) allocsize *= 2;  // allow blocks of 16, 32, 64, ...
   if (len < allocsize) len = allocsize;

   if (len > (TMPBUFSIZ >> 1)) return NULL; // check again

   if ((i + len) > TMPBUFSIZ) i = 0;
   ret = bufp + i;
   i += len;

   return ret;
}

/*
 * return a newly allocated block for string <s>. Cut off string <s> for
 * a maximum length of <len> chars. Always ensure a null byte follows.
 */
char *save_string(char *s, int len)
{
   int l;
   char *ret, *p;

   if (!s || !*s) return s;
   l = StrLen(s);
   if (len > 0  && len < l) l = len;
   p = ret = MemPtrNew (l + 1);
   if (!ret) return NULL;		// Oops, no memory ???
   while ((p - ret) < l) *p++ = *s++;	// strncpy()
   *p = 0;
   return ret;
}
