#include <Common.h>
#include <System/SysAll.h>
#include "wlists.h"
#include "kfz.h"

/*
 * WLISTS for the PalmPilot
 */

long _wlistcount = 0;

wlist * genwlist()
{
   wlist *ret;

   ret = (wlist *) MemPtrNew(sizeof(wlist));
   if (!ret) return NULL;
   _wlistcount++;

   MemSet(ret, sizeof(wlist), 0);
   return ret;
}

void incrwlist(wlist * w)
{
   char **tmp;
   Err rc;
   int n;

   if (w->ntab < 32) {
      n = w->ntab * 2;
      if (n < 4) n = 4;
   } else {
      n = w->ntab + 32;
   }

   if (w->wtab) {
      rc = MemPtrResize(w->wtab, n * sizeof(char *));
      if (rc) {
	 tmp = MemPtrNew(n * sizeof(char *));
	 if (!tmp) return;
	 MemMove(tmp, w->wtab, w->ntab * sizeof(char *));
	 w->wtab = tmp;
      }
   } else {
      w->wtab = MemPtrNew(n * sizeof(char *));
   }
   if (w->wtab) {
      MemSet(&(w->wtab[w->ntab]), (n - w->ntab) * sizeof(char *), 0);
      w->ntab = n;
   }
}

wlist * addwlist(w, s) wlist * w; char * s;
{
   if (!s) return w;
   if (w->nwords >= w->ntab) incrwlist(w);
   if (w->nwords < w->ntab) w->wtab[w->nwords++] = save_string(s, 0);
   return w;
}

void delwlist(w) wlist * w;
{
   int i;

   if (!w) return;
   if (w->wtab) {
      for (i = 0; i < w->nwords; i++) {
	 if (w->wtab[i]) MemPtrFree(w->wtab[i]);
      }
      MemPtrFree(w->wtab);
   }
   MemPtrFree(w);
   _wlistcount--;
}
